Bug 668173 - Review Request: lemonpos - Lemon Point of Sale
Review Request: lemonpos - Lemon Point of Sale
Status: CLOSED NOTABUG
Product: Fedora
Classification: Fedora
Component: Package Review (Show other bugs)
rawhide
All Linux
medium Severity medium
: ---
: ---
Assigned To: Magnus Tuominen
Fedora Extras Quality Assurance
:
Depends On:
Blocks:
  Show dependency treegraph
 
Reported: 2011-01-08 11:39 EST by Siddharth Sharma
Modified: 2012-03-06 12:56 EST (History)
3 users (show)

See Also:
Fixed In Version:
Doc Type: Bug Fix
Doc Text:
Story Points: ---
Clone Of:
Environment:
Last Closed: 2012-03-06 12:56:35 EST
Type: ---
Regression: ---
Mount Type: ---
Documentation: ---
CRM:
Verified Versions:
Category: ---
oVirt Team: ---
RHEL 7.3 requirements from Atomic Host:
Cloudforms Team: ---
magnus.tuominen: fedora‑review+
limburgher: fedora‑cvs+


Attachments (Terms of Use)

  None (edit)
Description Siddharth Sharma 2011-01-08 11:39:38 EST
Spec URL: http://siddharths.fedorapeople.org/SPECS/lemonpos.spec
SRPM URL: http://siddharths.fedorapeople.org/SRPMS/lemonpos-0.9.3-1.fc14.src.rpm
Description: Lemon is an open source POS (point of sale) for Linux, and other Unix.   
It is a general POS, not targeted to a specific business.  
  
It has been developed for ease of use and customization, and to support  
bar-code scanners and ticket printers. At this point, it has been tested  
with a parallel port ticket printer (Star Micronics, SP500).  
  
More information on http://www.lemonpos.org/  

Authors:  
--------  
     Miguel Chávez Gamboa
Comment 1 Magnus Tuominen 2011-01-08 11:43:41 EST
I'll review this.
Comment 2 Magnus Tuominen 2011-01-09 10:02:43 EST
MUST: rpmlint must be run on the source rpm and all binary rpms the build produces. The output should be posted in the review.
-OK

rpmlint -iv lemonpos.spec 
lemonpos.spec: I: checking-url http://sourceforge.net/projects/lemonpos/files/real/lemonpos-0.9.3.tar.bz2 (timeout 10 seconds)
0 packages and 1 specfiles checked; 0 errors, 0 warnings.

rpmlint -iv lemonpos-0.9.3-1.fc14.src.rpm 
lemonpos.src: I: checking
lemonpos.src: I: checking-url http://www.lemonpos.org/ (timeout 10 seconds)
lemonpos.src: I: checking-url http://sourceforge.net/projects/lemonpos/files/real/lemonpos-0.9.3.tar.bz2 (timeout 10 seconds)
1 packages and 0 specfiles checked; 0 errors, 0 warnings.

MUST: The package must be named according to the Package Naming Guidelines.
-OK

MUST: The spec file name must match the base package %{name}, in the format %{name}.spec unless your package has an exemption.
-OK

MUST: The package must meet the Packaging Guidelines.
-OK

MUST: The package must be licensed with a Fedora approved license and meet the Licensing Guidelines .
-OK, GPLv2

MUST: The License field in the package spec file must match the actual license.
-OK, GPLv2

MUST: If (and only if) the source package includes the text of the license(s) in its own file, then that file, containing the text of the license(s) for the package must be included in %doc.
-OK

MUST: The spec file must be written in American English.
-OK

MUST: The spec file for the package MUST be legible.
-OK

MUST: The sources used to build the package must match the upstream source, as provided in the spec URL. Reviewers should use md5sum for this task. If no upstream URL can be specified for this package, please see the Source URL Guidelines for how to deal with this.

MUST: The package MUST successfully compile and build into binary rpms on at least one primary architecture.
-OK

MUST: If the package does not successfully compile, build or work on an architecture, then those architectures should be listed in the spec in ExcludeArch. Each architecture listed in ExcludeArch MUST have a bug filed in bugzilla, describing the reason that the package does not compile/build/work on that architecture. The bug number MUST be placed in a comment, next to the corresponding ExcludeArch line.
-OK

MUST: All build dependencies must be listed in BuildRequires, except for any that are listed in the exceptions section of the Packaging Guidelines ; inclusion of those as BuildRequires is optional. Apply common sense.
-NOT OK, add BR: dekstop-file-utils, you are using %dekstop-file-validate

MUST: The spec file MUST handle locales properly. This is done by using the %find_lang macro. Using %{_datadir}/locale/* is strictly forbidden.
-NOT OK, you should install language files with the %find_lang macro

MUST: Every binary RPM package (or subpackage) which stores shared library files (not just symlinks) in any of the dynamic linker's default paths, must call ldconfig in %post and %postun.
-NOT OK, please use clearer paths in %files, using */*/*/* is very difficult to figure out.

MUST: Packages must NOT bundle copies of system libraries.
-OK

MUST: If the package is designed to be relocatable, the packager must state this fact in the request for review, along with the rationalization for relocation of that specific package. Without this, use of Prefix: /usr is considered a blocker.
-OK

MUST: A package must own all directories that it creates. If it does not create a directory that it uses, then it should require a package which does create that directory.
-NOT SURE

MUST: A Fedora package must not list a file more than once in the spec file's %files listings. (Notable exception: license texts in specific situations)
-NOT OK

MUST: Permissions on files must be set properly. Executables should be set with executable permissions, for example. Every %files section must include a %defattr(...) line.
-OK

MUST: Each package must consistently use macros.
-OK

MUST: The package must contain code, or permissable content.
-OK

MUST: Large documentation files must go in a -doc subpackage. (The definition of large is left up to the packager's best judgement, but is not restricted to size. Large can refer to either size or quantity).
-NOT OK, you have listed database_resources as a doc, but it is not, and left you the folder doc?

MUST: If a package includes something as %doc, it must not affect the runtime of the application. To summarize: If it is in %doc, the program must run properly if it is not present.
-OK

MUST: Header files must be in a -devel package.
-NOT SURE please use clearer paths in %files

MUST: Static libraries must be in a -static package.
-NOT SURE please use clearer paths in %files

MUST: If a package contains library files with a suffix (e.g. libfoo.so.1.1), then library files that end in .so (without suffix) must go in a -devel package.
-NOT SURE please use clearer paths in %files

MUST: In the vast majority of cases, devel packages must require the base package using a fully versioned dependency: Requires: %{name} = %{version}-%{release}
-NOT SURE please use clearer paths in %files

MUST: Packages must NOT contain any .la libtool archives, these must be removed in the spec if they are built.[20]
-NOT SURE please use clearer paths in %files

MUST: Packages containing GUI applications must include a %{name}.desktop file, and that file must be properly installed with desktop-file-install in the %install section. If you feel that your packaged GUI application does not need a .desktop file, you must put a comment in the spec file with your explanation.
-OK

MUST: Packages must not own files or directories already owned by other packages. The rule of thumb here is that the first package to be installed should own the files or directories that other packages may rely upon. This means, for example, that no package in Fedora should ever share ownership with any of the files or directories owned by the filesystem or man package. If you feel that you have a good reason to own a file or directory that another package owns, then please present that at package review time.
-NOT SURE please use clearer paths in %files

MUST: All filenames in rpm packages must be valid UTF-8.
-OK


SHOULD Items:
Items marked as SHOULD are things that the package (or reviewer) SHOULD do, but is not required to do.
SHOULD: If the source package does not include license text(s) as a separate file from upstream, the packager SHOULD query upstream to include it.
SHOULD: The description and summary sections in the package spec file should contain translations for supported Non-English languages, if available.
SHOULD: The reviewer should test that the package builds in mock.
-Does not build.

SHOULD: The package should compile and build into binary rpms on all supported architectures.
-Does not build.

SHOULD: The reviewer should test that the package functions as described. A package should not segfault instead of running, for example.
SHOULD: If scriptlets are used, those scriptlets must be sane. This is vague, and left up to the reviewers judgement to determine sanity.
SHOULD: Usually, subpackages other than devel should require the base package using a fully versioned dependency.
SHOULD: The placement of pkgconfig(.pc) files depends on their usecase, and this is usually for development purposes, so should be placed in a -devel pkg. A reasonable exception is that the main pkg itself is a devel tool not installed in a user runtime, e.g. gcc or gdb.
SHOULD: If the package has file dependencies outside of /etc, /bin, /sbin, /usr/bin, or /usr/sbin consider requiring the package which provides the file instead of the file itself.
SHOULD: your package should contain man pages for binaries/scripts. If it doesn't, work with upstream to add them where they make sense.
References to the Fedora Packaging Guidelines

--------------------
This is not a complete review, but you can start by fixing the things mentioned and I'll resume when you have posted an updates spec and src.rpm.
Comment 3 Kevin Kofler 2011-01-09 17:08:50 EST
About the specfile itself:

> %{_kde4_datadir}/kde4/apps/*/*.*  
> %{_kde4_datadir}/kde4/apps/*/*/*.*  
> %{_kde4_datadir}/kde4/apps/*/*/*/*.*  

Please do not use this. It's OK to use */*/*.png for icons, but not for kde4/apps. And you need not (and in fact must not) list those files: listing a directory already automatically includes the files in it!

> %{_kde4_datadir}/kde4/apps/lemon  
> %{_kde4_datadir}/kde4/apps/lemon/images  
> %{_kde4_datadir}/kde4/apps/lemon/styles  
> %{_kde4_datadir}/kde4/apps/lemon/styles/elegant  
> %{_kde4_datadir}/kde4/apps/lemon/styles/simple  

Only the first of these lines is needed, this automatically includes all the files and subdirectories.

> %{_kde4_datadir}/kde4/apps/squeeze  
> %{_kde4_datadir}/kde4/apps/squeeze/images  
> %{_kde4_datadir}/kde4/apps/squeeze/styles  
> %{_kde4_datadir}/kde4/apps/squeeze/styles/simple   

Likewise.

You should also use %{_kde4_appsdir} instead of %{_kde4_datadir}/kde4/apps.

> %{_kde4_datadir}/locale/*/*/*.mo

No! As Magnus pointed out, that's what %find_lang is for.

> *Sat Jan 8 2011 siddharth Sharma <siddharths@fedoraproject.org> - 0.9.3-1

Space missing after the '*'.

And customarily, the first letter of a person's name in Latin letters gets capitalized.


About the review:

> -NOT OK, please use clearer paths in %files, using */*/*/* is very difficult
> to figure out.

Huh? Those */*/*/*.* don't match anything outside of the _kde4_appsdir, there won't be any shared or static libs, header files etc. in there unless the upstream package is broken. (That said, it's indeed bad to use these wildcards.)

And a way to figure out what files actually end up in the package is to look at the contents of the binary RPM. But of course if you can't get the SRPM to build, that won't help…
Comment 4 Kevin Kofler 2011-01-11 00:55:00 EST
For the %find_lang, use:

%find_lang lemon
%find_lang squeeze
cat lemon.lang squeeze.lang >%{name}.lang
Comment 5 Susi Lehtola 2011-01-12 05:06:06 EST
Siddharth: the fedora_review flag is set by the reviewer.

Magnus: since you are reviewing, set the bug status to ASSIGNED and set the fedora_review flag to ?.
Comment 6 Magnus Tuominen 2011-01-12 05:19:42 EST
Done.
Comment 7 Siddharth Sharma 2011-10-29 16:36:12 EDT
SPEC and SRPM has been updated with suggested changes, please review it :)

Spec URL: http://siddharths.fedorapeople.org/SPECS/lemonpos.spec
SRPM URL:
http://siddharths.fedorapeople.org/SRPMS/lemonpos-0.9.4-1.fc16.src.rpm
Description: Lemon is an open source POS (point of sale) for Linux, and other
Unix.   
It is a general POS, not targeted to a specific business.  

It has been developed for ease of use and customization, and to support  
bar-code scanners and ticket printers. At this point, it has been tested  
with a parallel port ticket printer (Star Micronics, SP500).  

More information on http://www.lemonpos.org/  

Authors:  
--------  
     Miguel Chávez Gamboa
Comment 8 Magnus Tuominen 2011-10-30 01:57:58 EDT
Resuming review:

MUST: rpmlint must be run on the source rpm and all binary rpms the build produces. The output should be posted in the review.
-?

rpmlint -iv lemonpos.spec
lemonpos.spec: I: checking-url http://sourceforge.net/projects/lemonpos/files/real/lemonpos-0.9.4-rc7.tar.bz2 (timeout 10 seconds)
0 packages and 1 specfiles checked; 0 errors, 0 warnings.

rpmlint -iv lemonpos-0.9.4-1.fc16.src.rpm
lemonpos.src: I: checking
lemonpos.src: I: checking-url http://www.lemonpos.org/ (timeout 10 seconds)
lemonpos.src: I: checking-url http://sourceforge.net/projects/lemonpos/files/real/lemonpos-0.9.4-rc7.tar.bz2 (timeout 10 seconds)
lemonpos.src: W: file-size-mismatch lemonpos-0.9.4-rc7.tar.bz2 = 4429702, http://sourceforge.net/projects/lemonpos/files/real/lemonpos-0.9.4-rc7.tar.bz2 = 31204
The size of the file in the package does not match the size indicated by
peeking at its URL.  Verify that the file in the package has the intended
contents.

-There is something wrong with the source url, spectool -g fetches bad package
-A working url would be http://downloads.sourceforge.net/project/lemonpos/citronic/lemonpos-0.9.4-rc7.tar.bz2

1 packages and 0 specfiles checked; 0 errors, 1 warnings.

MUST: The package must be named according to the Package Naming Guidelines.
-OK

MUST: The spec file name must match the base package %{name}, in the format %{name}.spec unless your package has an exemption.
-OK

MUST: The package must meet the Packaging Guidelines.
-OK

MUST: The package must be licensed with a Fedora approved license and meet the Licensing Guidelines .
-OK, GPLv2

MUST: The License field in the package spec file must match the actual license.
-OK, GPLv2

MUST: If (and only if) the source package includes the text of the license(s) in its own file, then that file, containing the text of the license(s) for the package must be included in %doc.
-OK

MUST: The spec file must be written in American English.
-OK

MUST: The spec file for the package MUST be legible.
-OK

MUST: The sources used to build the package must match the upstream source, as provided in the spec URL. Reviewers should use md5sum for this task. If no upstream URL can be specified for this package, please see the Source URL Guidelines for how to deal with this.
- upstream      7b589c017e2213a24d34fdd6eccf5ce5
- src.rpm       4c45982ff54fdc04094a20f2feafc88f
- mismatch because of bad source url, please fix.

MUST: The package MUST successfully compile and build into binary rpms on at least one primary architecture.
-OK

MUST: If the package does not successfully compile, build or work on an architecture, then those architectures should be listed in the spec in ExcludeArch. Each architecture listed in ExcludeArch MUST have a bug filed in bugzilla, describing the reason that the package does not compile/build/work on that architecture. The bug number MUST be placed in a comment, next to the corresponding ExcludeArch line.
-OK

MUST: All build dependencies must be listed in BuildRequires, except for any that are listed in the exceptions section of the Packaging Guidelines ; inclusion of those as BuildRequires is optional. Apply common sense.
-OK

MUST: The spec file MUST handle locales properly. This is done by using the %find_lang macro. Using %{_datadir}/locale/* is strictly forbidden.
-OK

MUST: Every binary RPM package (or subpackage) which stores shared library files (not just symlinks) in any of the dynamic linker's default paths, must call ldconfig in %post and %postun.
-OK

MUST: Packages must NOT bundle copies of system libraries.
-OK

MUST: If the package is designed to be relocatable, the packager must state this fact in the request for review, along with the rationalization for relocation of that specific package. Without this, use of Prefix: /usr is considered a blocker.
-OK

MUST: A package must own all directories that it creates. If it does not create a directory that it uses, then it should require a package which does create that directory.
-OK

MUST: A Fedora package must not list a file more than once in the spec file's %files listings. (Notable exception: license texts in specific situations)
-OK

MUST: Permissions on files must be set properly. Executables should be set with executable permissions, for example. Every %files section must include a %defattr(...) line.
-OK

MUST: Each package must consistently use macros.
-OK

MUST: The package must contain code, or permissable content.
-OK

MUST: Large documentation files must go in a -doc subpackage. (The definition of large is left up to the packager's best judgement, but is not restricted to size. Large can refer to either size or quantity).
-NOT OK, you have listed database_resources as a doc, but it is not, and left you the folder doc?

MUST: If a package includes something as %doc, it must not affect the runtime of the application. To summarize: If it is in %doc, the program must run properly if it is not present.
-OK

MUST: Header files must be in a -devel package.
-OK

MUST: Static libraries must be in a -static package.
-OK

MUST: If a package contains library files with a suffix (e.g. libfoo.so.1.1), then library files that end in .so (without suffix) must go in a -devel package.
-OK

MUST: In the vast majority of cases, devel packages must require the base package using a fully versioned dependency: Requires: %{name} = %{version}-%{release}
-OK

MUST: Packages must NOT contain any .la libtool archives, these must be removed in the spec if they are built.[20]
-OK

MUST: Packages containing GUI applications must include a %{name}.desktop file, and that file must be properly installed with desktop-file-install in the %install section. If you feel that your packaged GUI application does not need a .desktop file, you must put a comment in the spec file with your explanation.
-OK

MUST: Packages must not own files or directories already owned by other packages. The rule of thumb here is that the first package to be installed should own the files or directories that other packages may rely upon. This means, for example, that no package in Fedora should ever share ownership with any of the files or directories owned by the filesystem or man package. If you feel that you have a good reason to own a file or directory that another package owns, then please present that at package review time.
-OK

MUST: All filenames in rpm packages must be valid UTF-8.
-OK


SHOULD Items:
Items marked as SHOULD are things that the package (or reviewer) SHOULD do, but is not required to do.
SHOULD: If the source package does not include license text(s) as a separate file from upstream, the packager SHOULD query upstream to include it.
SHOULD: The description and summary sections in the package spec file should contain translations for supported Non-English languages, if available.
SHOULD: The reviewer should test that the package builds in mock.
-Does not build.
-Fails with:
-No translations found for lemon in /builddir/build/BUILDROOT/lemonpos-0.9.4-1.fc16.x86_64
-error: Bad exit status from /var/tmp/rpm-tmp.QeXyRl (%check)
-Bad exit status from /var/tmp/rpm-tmp.QeXyRl (%check)


SHOULD: The package should compile and build into binary rpms on all supported architectures.
-Built on F-16 x86_64 using rpmbuild, mock fails.

SHOULD: The reviewer should test that the package functions as described. A package should not segfault instead of running, for example.
-Works

SHOULD: If scriptlets are used, those scriptlets must be sane. This is vague, and left up to the reviewers judgement to determine sanity.
SHOULD: Usually, subpackages other than devel should require the base package using a fully versioned dependency.
SHOULD: The placement of pkgconfig(.pc) files depends on their usecase, and this is usually for development purposes, so should be placed in a -devel pkg. A reasonable exception is that the main pkg itself is a devel tool not installed in a user runtime, e.g. gcc or gdb.
SHOULD: If the package has file dependencies outside of /etc, /bin, /sbin, /usr/bin, or /usr/sbin consider requiring the package which provides the file instead of the file itself.
SHOULD: your package should contain man pages for binaries/scripts. If it doesn't, work with upstream to add them where they make sense.
References to the Fedora Packaging Guidelines


Summary: fix the source url and make it build in mock ;-)
no other complaints, at least not right now.
Don't know why fails when rpmbuild builds it just fine
Comment 9 Siddharth Sharma 2011-11-01 04:23:59 EDT
SPEC and SRPM have been re-updated with suggested changes and building with mock

Spec URL: http://siddharths.fedorapeople.org/SPECS/lemonpos.spec
SRPM URL: http://siddharths.fedorapeople.org/SRPMS/lemonpos-0.9.4-2.fc16.src.rpm

Now this builds with mock as well
Comment 10 Magnus Tuominen 2011-11-07 12:40:44 EST
Approved!
Comment 11 Siddharth Sharma 2011-11-11 07:06:27 EST
New Package SCM Request
=======================
Package Name: lemonpos
Short Description: Lemon is an open source POS (point of sale) for Linux.
Owners: siddharths
Branches: f16
InitialCC: siddharths
Comment 12 Gwyn Ciesla 2011-11-11 08:20:06 EST
Git done (by process-git-requests).
Comment 13 Siddharth Sharma 2012-03-06 12:56:35 EST
Package in repository

Note You need to log in before you can comment on or make changes to this bug.